#! /usr/bin/python
# -*- coding: utf-8 -*-
#
# favicon.py
#
# Copyright (C) 2010 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
from gi.repository import GdkPixbuf
import sys
import shutil
import urllib2
import lxml.html
import urlparse


HEADERS = {
	'User-Agent': 'urllib2 (Python %s)' % sys.version.split()[0],
	'Connection': 'close',
}

def get_favicon_url(url):
	if not url.endswith('/'):
		url += '/'
	request = urllib2.Request(url, headers=HEADERS)
	try:
		content = urllib2.urlopen(request).read(2048)
	except(urllib2.HTTPError, urllib2.URLError):
		return None
	icon_path = lxml.html.fromstring(content.lower()).xpath(
		'//link[@rel="icon" or @rel="shortcut icon"]/@href'
	)
	if icon_path:
		try:
			if icon_path[0].startswith('http') or icon_path[0].startswith('https'):
				urlicon = icon_path[0]
			else:
				o = urlparse.urlparse(url)
				urlicon = urlparse.urlunparse((o.scheme,o.netloc,icon_path[0], '', '', ''))
			print urlicon
			request = urllib2.Request(urlicon, headers=HEADERS)
			icon = urllib2.urlopen(request).read()
			return icon
		except(urllib2.HTTPError, urllib2.URLError):
			print urlicon
			return None
	return None

def get_favicon(url):
	icon = get_favicon_url(url)
	if icon != None:
		open('/tmp/google_reader_indicator_favicon','wb').write(icon)

def get_favicon_pixbuf(url):
	icon = get_favicon_url(url)
	if icon!= None:
		loader = GdkPixbuf.PixbufLoader()
		loader.write(icon)
		loader.close()
		return loader.get_pixbuf()
	print 'None: url: %s / icon:%s'%(url,icon)
	return None
	
if __name__ == '__main__':
	get_favicon('http://askubuntu.com/questions/65990/how-do-i-access-wine-applications-from-unity')
	get_favicon('http://lxer.com/')
