#! /usr/bin/python

from gi.repository import Dee
# FIXME: Some weird bug in Dee or PyGI makes Dee fail unless we probe
#		it *before* we import the Unity module... ?!
_m = dir(Dee.SequenceModel)

# Import the module for sending indications to the Message Menu
from gi.repository import Indicate

# Import our base module to access icon paths
#import hello_unity



import os
import gi
gi.require_version('Gtk', '3.0')
from gi.repository import GObject
from gi.repository import AppIndicator3 as appindicator
from gi.repository import Gtk
from gi.repository import Gdk
from gi.repository import GdkPixbuf
from gi.repository import Notify
from gi.repository import GLib
from configuration import Configuration
from optparse import OptionParser
import dbus
import dbus
import dbus.service
from dbus.mainloop.glib import DBusGMainLoop
import re
import os
import locale
import gettext
import webbrowser
import time
import urllib
import urllib2
from preferences import Preferences
import machine_information
import comun
import googlereaderapi
import htmlentitydefs
#import favicon

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(comun.APP, comun.LANGDIR)
gettext.textdomain(comun.APP)
_ = gettext.gettext

NEW_NEWS = 5
REFRESH_TIME = 60

def convert_html_entities(s):
	s = s.encode('utf8')
	matches = re.findall("&#\d+;", s)
	if len(matches) > 0:
		hits = set(matches)
		for hit in hits:
			name = hit[2:-1]
			try:
					entnum = int(name)
					s = s.replace(hit, unichr(entnum))
			except ValueError:
					pass

	matches = re.findall("&\w+;", s)
	hits = set(matches)
	amp = "&amp;"
	if amp in hits:
		hits.remove(amp)
	for hit in hits:
		name = hit[1:-1]
		if htmlentitydefs.name2codepoint.has_key(name):
			s = s.replace(hit, unichr(htmlentitydefs.name2codepoint[name]))
	s = s.replace(amp, "&")
	return s

def internet_on():
	try:
		response=urllib2.urlopen('http://google.com',timeout=1)
		return True
	except:
		pass
	return False

def add2menu(menu, text = None, icon = None, conector_event = None, conector_action = None):
	if text != None:
		if icon == None:
			menu_item = Gtk.MenuItem.new_with_label(text)
		else:
			if icon.__class__.__name__ == 'Pixbuf':
				image = Gtk.Image.new_from_pixbuf(icon)
			else:
				image = Gtk.Image.new_from_stock(icon, Gtk.IconSize.MENU)
			menu_item = Gtk.ImageMenuItem.new_with_label(text)
			menu_item.set_image(image)
			menu_item.set_always_show_image(True)
	else:
		if icon == None:
			menu_item = Gtk.SeparatorMenuItem()
		else:
			if icon.__class__.__name__ == 'Pixbuf':
				image = Gtk.Image.new_from_pixbuf(icon)
			else:
				image = Gtk.Image.new_from_stock(icon, Gtk.IconSize.MENU)
			menu_item = Gtk.ImageMenuItem()
			menu_item.set_image(image)
			menu_item.set_always_show_image(True)
	if conector_event != None and conector_action != None:				
		menu_item.connect(conector_event,conector_action)
	menu_item.show()
	menu.append(menu_item)
	return menu_item

def init_dbus():
    """Initialize dbus parameters"""
    global open_all_in_browser
    global mark_all_as_read
    global refresh
    global preferences

    bus = dbus.SessionBus()
    try:
        google_reader_indicator_service = bus.get_object\
                                ('es.atareao.google_reader_indicator_service',
                                '/es/atareao/google_reader_indicator_service')
        open_all_in_browser = google_reader_indicator_service.get_dbus_method\
                                ('open_all_in_browser',
                                'es.atareao.google_reader_indicator_service')
        mark_all_as_read = google_reader_indicator_service.get_dbus_method\
                                ('mark_all_as_read',
                                'es.atareao.google_reader_indicator_service')
        refresh = google_reader_indicator_service.get_dbus_method\
                                ('refresh',
                                'es.atareao.google_reader_indicator_service')
        preferences = google_reader_indicator_service.get_dbus_method\
                                ('preferences',
                                'es.atareao.google_reader_indicator_service')
    except:
        print('watchdog: Failed to initialize dbus.')
        exit(0)
        
class DBUSService(dbus.service.Object):

	def __init__(self, indicator):
		self.ind = indicator
		bus = dbus.SessionBus()
		bus_name = dbus.service.BusName('es.atareao.google_reader_indicator_service', bus)
		dbus.service.Object.__init__(self, bus_name,
							 '/es/atareao/google_reader_indicator_service')

	@dbus.service.method('es.atareao.google_reader_indicator_service')
	def open_all_in_browser(self):
		self.ind.open_all_in_browser()

	@dbus.service.method('es.atareao.google_reader_indicator_service')
	def mark_all_as_read(self):
		self.ind.mark_all_as_read()

	@dbus.service.method('es.atareao.google_reader_indicator_service')
	def refresh(self):
		self.ind.refresh()

	@dbus.service.method('es.atareao.google_reader_indicator_service')
	def preferences(self):
		self.ind.preferences()

class ModIndicator(Indicate.Indicator):
	def __init__(self,server,article):
		Indicate.Indicator.__init__(self)
		self.set_server(server)
		self.article = article

class GRI(object):
	def __init__(self):
		if dbus.SessionBus().request_name('es.atareao.GoogleReaderIndicator') != dbus.bus.REQUEST_NAME_REPLY_PRIMARY_OWNER:
			print "application already running"
			exit(0)		
		self.read_preferences()
		#
		self.last_notification = 0
		self.actualization_time = 0
		#
		self.indicate_server = Indicate.Server.ref_default()
		self.indicate_server.set_type("message")
		self.indicate_server.connect('server-display',self.apercibite)
		self.indicate_server.set_desktop_file("/usr/share/applications/google-reader-indicator.desktop")
		self.indicate_server.show()
		#
		indication = Indicate.Indicator.new_with_server(self.indicate_server)
		indication.set_property("subtype", "im")
		indication.set_property("sender", _('Mark all as read'))
		indication.connect("user-display", self.mark_all_as_read)
		indication.show()
		#
		self.inicializate()
		#
		self.work()
		#
		GObject.timeout_add_seconds(REFRESH_TIME, self.work)
		
	def apercibite(self,param1=None,param2=None):
		for indicator in self.indicators:
			indicator.set_property("draw-attention", "false")
		
	def remove_indication(self, indication, timestamp):		
		indication.set_displayed(True)
		self.gr.mark_as_browsed(indication.article.id,True)
		self.gr.mark_as_read(indication.article.id,True)
		webbrowser.open_new_tab(indication.article.uri)		
		self.indicate_server.remove_indicator(indication)
		self.indicators.remove(indication)		

	def read_preferences(self):
		conf = Configuration()
		user = conf.get('user')
		password = conf.get('password')			
		while user == None or password == None or user == '' or password == '':
			p = Preferences()
			if p.run() != Gtk.ResponseType.ACCEPT:
				exit(1)
			p.save_preferences()
			p.destroy()
			conf = Configuration()
			user = conf.get('user')
			password = conf.get('password')
		incorrect = True
		while incorrect:
			try:
				self.gr = googlereaderapi.GoogleReader(user,password)
				incorrect = False
			except urllib2.HTTPError,e2:
				if e2.code == 403:
					md = Gtk.MessageDialog(	parent = self,
											flags = Gtk.DialogFlags.MODAL | Gtk.DialogFlags.DESTROY_WITH_PARENT,
											type = Gtk.MessageType.ERROR,
											buttons = Gtk.ButtonsType.OK_CANCEL,
											message_format = _('The email or/and the password are incorrect\nplease, try again?'))
					if md.run() != Gtk.ResponseType.OK:
						exit(3)
					md.destroy()
					p = Preferences(self)
					if p.run() == Gtk.ResponseType.ACCEPT:
						p.save_preferences()
						conf = Configuration()
						user = conf.get('user')
						password = conf.get('password')			
					p.destroy()
			except urllib2.URLError,e:
				md = Gtk.MessageDialog(	parent = self,
										flags = Gtk.DialogFlags.MODAL | Gtk.DialogFlags.DESTROY_WITH_PARENT,
										type = Gtk.MessageType.ERROR,
										buttons = Gtk.ButtonsType.OK_CANCEL,
										message_format = _('There is no connection\ntry again?'))
				if md.run() == Gtk.ResponseType.CANCEL:
					exit(3)
				md.destroy()				
									
	def work(self):
		while internet_on() == False:
			time.sleep(1)
		'''
		if (time.time()-self.actualization_time) > long(self.configuration.get('refresh_time'))*60:
			self.actualization_time = time.time()
		'''
		self.update()
		return True
				
	def get_help_menu(self):
		help_menu =Gtk.Menu()
		#
		add2menu(help_menu,text = _('Application Web...'),conector_event = 'activate',conector_action = lambda x: webbrowser.open('https://launchpad.net/google-reader-indicator'))
		add2menu(help_menu,text = _('Get help online...'),conector_event = 'activate',conector_action = lambda x: webbrowser.open('https://answers.launchpad.net/google-reader-indicator'))
		add2menu(help_menu,text = _('Translate this application...'),conector_event = 'activate',conector_action = lambda x: webbrowser.open('https://translations.launchpad.net/google-reader-indicator'))
		add2menu(help_menu,text = _('Report a bug...'),conector_event = 'activate',conector_action = lambda x: webbrowser.open('https://bugs.launchpad.net/google-reader-indicator'))
		add2menu(help_menu)
		add2menu(help_menu,text = _('About'),conector_event = 'activate',conector_action = self.menu_about_response)
		#
		help_menu.show()
		#
		return help_menu
		
	def article_exists(self,id):
		if len(self.indicators)>0:
			for indicator in self.indicators:
				if id == indicator.article.id:
					return True
			return False
		return True

	def inicializate(self):
		self.indicators = list()
		self.indicators_visibles = list()
		self.number_of_indicators_in_server = 0		
		n = self.gr.get_unread_count()
		unread_list = self.gr.get_reading_list(n)['items']
		for unread in unread_list:
			unread_article = googlereaderapi.Article(unread)
			indication = ModIndicator(self.indicate_server,unread_article)
			indication.set_property("subtype", "im")
			indication.set_property("sender", convert_html_entities(unread_article.short_title))
			indication.connect("user-display", self.remove_indication)
			self.indicators.append(indication)

	def update(self):
		news = []
		n = self.gr.get_unread_count()
		unread_list = self.gr.get_reading_list(n)['items']
		for unread in unread_list:
			unread_article = googlereaderapi.Article(unread)
			if not self.article_exists(unread_article.id):
				indication = ModIndicator(self.indicate_server,unread_article)
				indication.set_property("subtype", "im")
				indication.set_property("sender", convert_html_entities(unread_article.short_title))
				indication.connect("user-display", self.remove_indication)
				self.indicators.append(indication)
				news.append(indication)
		for indicator in news[0:NEW_NEWS]:
			self.indicate_server.add_indicator(indicator)
			indicator.set_property("draw-attention", "true")
			indicator.show()
			self.indicators_visibles.append(indicator)
			if len(self.indicators_visibles) > NEW_NEWS:
				indicator = self.indicators_visibles.pop(0)
				indicator.set_property("draw-attention", "false")
				indicator.hide()
				self.indicate_server.remove_indicator(indicator)
			#
			date = (time.strftime("%A, %d - %B - %Y %H:%M",time.localtime(indicator.article.published))).decode('utf8')
			res = convert_html_entities(indicator.article.title)
			msg = (res+ '\n ').decode('utf8')+date
			if indicator.article.sitename and len(indicator.article.sitename)>0:
				title = convert_html_entities(indicator.article.sitename)
			else:
				title = 'Google Reader Indicator'
			the_icon = comun.ICON
			#
			notification = Notify.Notification.new(title,msg,the_icon)
			notification.show()	
		
	def menu_refresh(self,widget):
		self.actualization_time = time.time()
		self.update()

	def open_all_in_browser(self):
		for indication in self.indicators:
			indication.set_displayed(True)
			self.gr.mark_as_browsed(indication.id,True)
			self.gr.mark_as_read(indication.id,True)
			webbrowser.open_new_tab(indication.uri)		
			self.indicate_server.remove_indicator(indication)
			self.indicators.remove(indication)		
		self.update()
			
	def mark_all_as_read(self):
		for indication in self.indicators:
			indication.set_displayed(True)
			self.gr.mark_as_browsed(indication.id,True)
			self.gr.mark_as_read(indication.id,True)
			self.indicate_server.remove_indicator(indication)
			self.indicators.remove(indication)		
		self.update()

	def preferences(self):
		p = Preferences()
		self.read_preferences()
		self.update()
		
	def menu_about_response(self,widget):
		widget.set_sensitive(False)
		ad=Gtk.AboutDialog()
		ad.set_name(comun.APPNAME)
		ad.set_version(comun.VERSION)
		ad.set_copyright('Copyrignt (c) 2010-2012\nLorenzo Carbonell')
		ad.set_comments(_('A Google Reader Indicator'))
		ad.set_license(''+
		'This program is free software: you can redistribute it and/or modify it\n'+
		'under the terms of the GNU General Public License as published by the\n'+
		'Free Software Foundation, either version 3 of the License, or (at your option)\n'+
		'any later version.\n\n'+
		'This program is distributed in the hope that it will be useful, but\n'+
		'WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY\n'+
		'or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for\n'+
		'more details.\n\n'+
		'You should have received a copy of the GNU General Public License along with\n'+
		'this program.  If not, see <http://www.gnu.org/licenses/>.')
		ad.set_website('http://www.atareao.es')
		ad.set_website_label('http://www.atareao.es')
		ad.set_authors(['Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'])
		ad.set_documenters(['Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'])
		ad.set_logo(GdkPixbuf.Pixbuf.new_from_file(comun.ICON))
		ad.set_icon(GdkPixbuf.Pixbuf.new_from_file(comun.ICON))
		ad.set_program_name(comun.APPNAME)
		ad.run()
		ad.hide()
		ad.destroy()
		widget.set_sensitive(True)
		
	def menu_exit_response(self,widget):
		exit(0)

if __name__ == '__main__':
	usage_msg = _('usage: %prog [options]')
	parser = OptionParser(usage=usage_msg, add_help_option=False)
	parser.add_option('-m', '--mark',
			action='store_true',
			dest='mark_all_as_read',
			default=False,
			help=_('mark all as read.'))
	parser.add_option('-o', '--open',
			action='store_true',
			dest='open_all_in_browser',
			default=False,
			help=_('Open all in browser'))
	parser.add_option('-p', '--preferences',
			action='store_true',
			dest='preferences',
			default=False,
			help=_('show preferences dialog'))
	parser.add_option('-r', '--refresh',
			action='store_true',
			dest='refresh',
			default=False,
			help=_('refresh rss'))

	(options, args) = parser.parse_args()

	if options.mark_all_as_read:
		init_dbus()
		mark_all_as_read()
	elif options.open_all_in_browser:
		init_dbus()
		open_all_in_browser()
	elif options.preferences:
		init_dbus()
		preferences()
	elif options.refresh:
		init_dbus()
		refresh()
	else: 
		print machine_information.get_information()
		print 'Google-Reader-Indicator version: %s'%comun.VERSION
		print '#####################################################'
		DBusGMainLoop(set_as_default=True)
		Notify.init('google-reader-indicator')
		gri=GRI()
		ms = DBUSService(gri)
		Gtk.main()
	exit(0)
