#! /usr/bin/python
# -*- coding: iso-8859-15 -*-
#
__author__='atareao'
__date__ ='$06-jun-2010 12:34:44$'
#
# <one line to give the program's name and a brief idea of what it does.>
#
# Copyright (C) 2010 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#

import gi
gi.require_version('Gtk', '3.0')
from gi.repository import Gtk
from gi.repository import GdkPixbuf
from gi.repository import Notify

import os
import shutil
import locale
import gettext
from configuration import Configuration
import comun

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(comun.APP, comun.LANGDIR)
gettext.textdomain(comun.APP)
_ = gettext.gettext


class Preferences(Gtk.Dialog):
	def __init__(self):
		self.ok = False
		#
		title = comun.APPNAME + ' | '+_('Preferences')
		Gtk.Dialog.__init__(self, title,None,Gtk.DialogFlags.MODAL | Gtk.DialogFlags.DESTROY_WITH_PARENT,(Gtk.STOCK_CANCEL, Gtk.ResponseType.REJECT,Gtk.STOCK_OK, Gtk.ResponseType.ACCEPT))
		self.set_position(Gtk.WindowPosition.CENTER_ALWAYS)
		self.set_size_request(400, 150)
		self.connect('destroy', self.close_application)
		self.set_icon_from_file(comun.ICON)
		self.set_resizable(False)
		#
		vbox0 = Gtk.VBox(spacing = 5)
		vbox0.set_border_width(5)
		self.get_content_area().add(vbox0)
		#
		notebook = Gtk.Notebook.new()
		vbox0.add(notebook)
		#
		frame1 = Gtk.Frame()
		notebook.append_page(frame1,Gtk.Label.new(_('Login')))
		#
		table1 = Gtk.Table(rows = 2, columns = 2)
		table1.set_border_width(5)
		table1.set_col_spacings(5)
		table1.set_row_spacings(5)
		frame1.add(table1)
		#
		label11 = Gtk.Label.new(_('User')+':')
		label11.set_alignment(0,.5)
		table1.attach(label11,0,1,0,1,xoptions=Gtk.AttachOptions.FILL, yoptions=Gtk.AttachOptions.FILL, xpadding=0, ypadding=5)
		#
		label12 = Gtk.Label.new(_('Password')+':')
		label12.set_alignment(0,.5)
		table1.attach(label12,0,1,1,2,xoptions=Gtk.AttachOptions.FILL, yoptions=Gtk.AttachOptions.FILL, xpadding=0, ypadding=5)
		#
		self.entry1 = Gtk.Entry()
		self.entry1.set_width_chars(30)
		table1.attach(self.entry1,1,2,0,1,xoptions=Gtk.AttachOptions.FILL, yoptions=Gtk.AttachOptions.FILL, xpadding=0, ypadding=5)
		#
		self.entry2 = Gtk.Entry()
		self.entry2.set_visibility(False)
		self.entry2.set_width_chars(30)
		table1.attach(self.entry2,1,2,1,2,xoptions=Gtk.AttachOptions.FILL, yoptions=Gtk.AttachOptions.FILL, xpadding=0, ypadding=5)
		'''
		#
		frame2 = Gtk.Frame()
		notebook.append_page(frame2,Gtk.Label.new(_('Options')))
		table2 = Gtk.Table(rows = 4, columns = 2)
		table2.set_border_width(5)
		table2.set_col_spacings(5)
		table2.set_row_spacings(5)
		frame2.add(table2)
		#
		label21 = Gtk.Label.new(_('Time between updates')+':')
		label21.set_alignment(0,.5)
		table2.attach(label21,0,1,0,1,xoptions=Gtk.AttachOptions.FILL, yoptions=Gtk.AttachOptions.FILL, xpadding=0, ypadding=5)
		#
		self.spin3 = Gtk.SpinButton()
		self.spin3.set_range(5,100)
		self.spin3.set_increments(5,10)
		table2.attach(self.spin3,1,2,0,1,xoptions=Gtk.AttachOptions.FILL, yoptions=Gtk.AttachOptions.FILL, xpadding=0, ypadding=5)
		#
		label22 = Gtk.Label.new(_('Autostart')+':')
		label22.set_alignment(0,.5)
		table2.attach(label22,0,1,1,2,xoptions=Gtk.AttachOptions.FILL, yoptions=Gtk.AttachOptions.FILL, xpadding=0, ypadding=5)
		#
		self.checkbox4 = Gtk.CheckButton()
		table2.attach(self.checkbox4,1,2,1,2,xoptions=Gtk.AttachOptions.FILL, yoptions=Gtk.AttachOptions.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		label31 = Gtk.Label.new(_('Select icon theme')+':')
		label31.set_alignment(0,0.5)
		table2.attach(label31,0,2,2,3,xoptions=Gtk.AttachOptions.FILL, yoptions=Gtk.AttachOptions.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		self.radiobutton31 = Gtk.RadioButton.new_with_label_from_widget(None,_('Light'))
		table2.attach(self.radiobutton31,0,1,3,4,xoptions=Gtk.AttachOptions.FILL, yoptions=Gtk.AttachOptions.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		self.radiobutton32 = Gtk.RadioButton.new_with_label_from_widget(self.radiobutton31,_('Dark'))
		table2.attach(self.radiobutton32,1,2,3,4,xoptions=Gtk.AttachOptions.FILL, yoptions=Gtk.AttachOptions.FILL, xpadding=0, ypadding=5)
		#***************************************************************		
		'''
		#
		self.load_preferences()
		#
		self.show_all()
		#
		'''
		if self.run() == Gtk.ResponseType.ACCEPT:
			self.ok = True
			self.save_preferences()
		self.destroy()
		'''

	def load_preferences(self):
		configuration = Configuration()
		#
		email = configuration.get('user')
		password = configuration.get('password')
		'''
		refresh_time = configuration.get('refresh_time')
		theme = configuration.get('theme')
		#
		self.entry1.set_text(email)
		self.entry2.set_text(password)
		self.spin3.set_value(long(refresh_time))
		if theme == 'light':
			self.radiobutton31.set_active(True)
		else:
			self.radiobutton32.set_active(True)		
		if os.path.exists(os.path.join(os.getenv("HOME"),".config/autostart/google-reader-indicator-autostart.desktop")):
			self.checkbox4.set_active(True)
		'''
		
	def save_preferences(self):
		email = self.entry1.get_text()
		password = self.entry2.get_text()
		'''
		refresh_time = long(self.spin3.get_value())
		'''
		configuration = Configuration()
		#
		configuration.set('password',self.entry2.get_text())
		configuration.set('user',self.entry1.get_text())
		configuration.save()
		'''
		configuration.set('refresh_time',str(long(self.spin3.get_value())))
		if self.radiobutton31.get_active():
			configuration.set('theme','light')
		else:
			configuration.set('theme','dark')
		configuration.save()
		filestart = os.path.join(os.getenv("HOME"),".config/autostart/google-reader-indicator-autostart.desktop")
		if self.checkbox4.get_active():
			if not os.path.exists(filestart):
				if not os.path.exists(os.path.dirname(filestart)):
					os.makedirs(os.path.dirname(filestart))
				shutil.copy('/usr/share/google-reader-indicator/google-reader-indicator-autostart.desktop', filestart)
		else:		
			if os.path.exists(filestart):
				os.remove(filestart)
		'''

	def close_application(self,widget):
		self.ok = False
	

if __name__ == "__main__":
	p=Preferences()
	if p.run() == Gtk.ResponseType.ACCEPT:
		p.save_preferences()
	p.destroy()
	exit(0)
		
